import { H as HyperWorker, L as LoadWorkersOpts, C as CreateWorkerConnectionOpts, B as BuildWorkersParams } from './worker-eba67fc3.js';
import { BullmqBackend } from './backend.js';
import { WorkerBackendOpts, WorkersMode } from '@hyperstackjs/typings';

declare const createBackend: ({ hyperworkers, redis, backendOpts, }: {
    hyperworkers: HyperWorker[];
    redis: any;
    backendOpts?: WorkerBackendOpts | undefined;
}) => BullmqBackend;
declare const loadWorkers: ({ workersGlob, mailersGlob }: LoadWorkersOpts) => {
    workers: any;
    mailers: any;
};
declare const createConnection: ({ redisUrl, rejectUnauthorized, }: CreateWorkerConnectionOpts) => Promise<any>;
declare const buildWorkers: ({ isInProcess, workersGlob, mailersGlob, mailerTemplatesRoot, mailerSettings, logger, redisUrl, backendOpts, truncate, beforeWorkers, afterWorkers, }: BuildWorkersParams, mode: WorkersMode) => Promise<{
    background: string;
    backend: null;
    connection: null;
    mode: WorkersMode;
    mailerTemplatesRoot: string;
    numMailers: number;
    numWorkers: number;
    workers: any;
    mailers: any;
} | {
    background: string;
    backend: BullmqBackend;
    connection: any;
    mailerTemplatesRoot: string;
    mode: WorkersMode;
    numMailers: number;
    numWorkers: number;
    workers: any;
    mailers: any;
}>;

export { buildWorkers, createBackend, createConnection, loadWorkers };
