var __create = Object.create;
var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __getOwnPropSymbols = Object.getOwnPropertySymbols;
var __getProtoOf = Object.getPrototypeOf;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __propIsEnum = Object.prototype.propertyIsEnumerable;
var __defNormalProp = (obj, key, value) => key in obj ? __defProp(obj, key, { enumerable: true, configurable: true, writable: true, value }) : obj[key] = value;
var __spreadValues = (a, b) => {
  for (var prop in b || (b = {}))
    if (__hasOwnProp.call(b, prop))
      __defNormalProp(a, prop, b[prop]);
  if (__getOwnPropSymbols)
    for (var prop of __getOwnPropSymbols(b)) {
      if (__propIsEnum.call(b, prop))
        __defNormalProp(a, prop, b[prop]);
    }
  return a;
};
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toESM = (mod, isNodeMode, target) => (target = mod != null ? __create(__getProtoOf(mod)) : {}, __copyProps(isNodeMode || !mod || !mod.__esModule ? __defProp(target, "default", { value: mod, enumerable: true }) : target, mod));
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);
var __decorateClass = (decorators, target, key, kind) => {
  var result = kind > 1 ? void 0 : kind ? __getOwnPropDesc(target, key) : target;
  for (var i = decorators.length - 1, decorator; i >= 0; i--)
    if (decorator = decorators[i])
      result = (kind ? decorator(target, key, result) : decorator(result)) || result;
  if (kind && result)
    __defProp(target, key, result);
  return result;
};

// src/hyperworker.ts
var hyperworker_exports = {};
__export(hyperworker_exports, {
  buildWorkers: () => buildWorkers,
  createBackend: () => createBackend,
  createConnection: () => createConnection,
  loadWorkers: () => loadWorkers
});
module.exports = __toCommonJS(hyperworker_exports);
var import_glob = __toESM(require("glob"));
var import_lodash2 = __toESM(require("lodash"));
var import_debug4 = __toESM(require("debug"));

// src/worker.ts
var import_reflect_metadata = require("reflect-metadata");
var import_debug = __toESM(require("debug"));
var debug = (0, import_debug.default)("hyperworker:worker");
var K_QUEUE_NAME = "hyperworker:queue-name";
var K_PRODUCER_ONLY = "hyperworker:queue-producer-only";
var queueAs = (queueName) => (target) => {
  return Reflect.defineMetadata(K_QUEUE_NAME, queueName, target);
};
var _HyperWorker = class {
  static clear() {
    this.logger = null;
    this.backend = null;
    this.inprocess = false;
    this.enqueue = null;
    this.reportError = (_err, _tags) => {
    };
  }
  static initWorker({ logger }) {
    this.logger = logger;
  }
  static setMode({
    inprocess,
    reportError
  }) {
    this.inprocess = inprocess;
    if (reportError) {
      this.reportError = reportError;
    }
  }
  static setTest(reportError) {
    this.setMode({ inprocess: true, reportError });
  }
  static get queueName() {
    return Reflect.getOwnMetadata(K_QUEUE_NAME, this) || this.name.toLowerCase();
  }
  static get producerOnly() {
    return Reflect.getOwnMetadata(K_PRODUCER_ONLY, this) || false;
  }
  static async performNow(args) {
    const w = new this();
    return w.perform({ data: args });
  }
  static async performLater(_args) {
    if (this.inprocess) {
      debug(`${this.name}: perform now '%o'`, _args);
      return this.performNow(_args);
    }
    debug(`${this.name}: perform later '%o'`, _args);
    return this.enqueue(_args, {});
  }
  static async jobCounts() {
    return await this.queue.getJobCounts();
  }
  get logger() {
    return _HyperWorker.logger;
  }
  perform(_args) {
  }
};
var HyperWorker = _HyperWorker;
HyperWorker.inprocess = false;
HyperWorker.logger = null;
HyperWorker.backend = null;
HyperWorker.enqueue = null;
HyperWorker.queue = null;
HyperWorker.reportError = (_err, _tags) => {
};

// src/mailer.ts
var import_nodemailer = __toESM(require("nodemailer"));
var import_debug2 = __toESM(require("debug"));
var import_nodemailer_stub = require("nodemailer-stub");
var debug2 = (0, import_debug2.default)("hyperworker:mailer");
var MailDelivery = class {
  constructor(MailerType, details) {
    this.MailerType = MailerType;
    this.details = details;
  }
  async deliver() {
    if (!HyperWorker.logger) {
      throw new Error("Logger is not configured. Did the app boot correctly?");
    }
    const { cyan, bold } = HyperWorker.logger.colors;
    const pref = bold(cyan("mailers:"));
    HyperWorker.logger.info(`${pref} ${this.MailerType.name} delivering`, this.details);
    return this.MailerType.performNow(this.details);
  }
  async deliverLater() {
    if (!HyperWorker.logger) {
      throw new Error("Logger is not configured. Did the app boot correctly?");
    }
    const { cyan, bold } = HyperWorker.logger.colors;
    const pref = bold(cyan("mailers:"));
    HyperWorker.logger.info(`${pref} ${this.MailerType.name} delivering later`, this.details);
    return this.MailerType.performLater(this.details);
  }
};
var Mailer = class extends HyperWorker {
  static clearDeliveries() {
    import_nodemailer_stub.interactsWithMail.flushMails();
  }
  static deliveries() {
    return import_nodemailer_stub.interactsWithMail.mails;
  }
  static lastMail() {
    return import_nodemailer_stub.interactsWithMail.lastMail();
  }
  static clear() {
    this.transport = null;
    this.send = false;
    this.preview = false;
    this.templatesRoot = null;
  }
  static initMailer({
    templatesRoot,
    settings
  }) {
    this.templatesRoot = templatesRoot;
    if (settings) {
      this.send = !!settings.send;
      this.preview = !!settings.preview;
      if (settings.delivery === "test") {
        this.transport = import_nodemailer_stub.stubTransport;
      } else if (settings.delivery === "smtp") {
        this.transport = import_nodemailer.default.createTransport(settings.smtpSettings);
      }
    }
  }
  static setNone() {
    this.send = false;
    this.preview = false;
    this.transport = null;
  }
  static setTest() {
    this.send = true;
    this.preview = false;
    this.transport = import_nodemailer_stub.stubTransport;
  }
  static setDevelopment() {
    this.send = false;
    this.preview = true;
    this.transport = null;
  }
  static setProduction() {
    this.send = true;
    this.preview = false;
  }
  async perform({ data }) {
    if (!HyperWorker.logger) {
      throw new Error("Logger is not configured. Did the app boot correctly?");
    }
    if (!Mailer.templatesRoot) {
      throw new Error("please set Mailer.templatesRoot");
    }
    const Email = require("email-templates");
    debug2(`mailer: send settings '%o'`, {
      send: Mailer.send,
      preview: Mailer.preview
    });
    const tmpl = new Email({
      views: { root: Mailer.templatesRoot, options: { extension: "ejs" } },
      transport: Mailer.transport || { jsonTransport: true },
      send: Mailer.send,
      preview: Mailer.preview,
      juice: false
    });
    try {
      debug2(`mailer: perform '%o'`, data);
      const res = await tmpl.send(data);
      const { cyan, bold } = HyperWorker.logger.colors;
      const pref = bold(cyan("mailers:"));
      HyperWorker.logger.info(`${pref} delivered email to: ${data.message.to}`, res);
      return res;
    } catch (e) {
      HyperWorker.logger.error(e);
      HyperWorker.reportError(e);
    }
  }
  static mail(details, _opts = {}) {
    details.message = __spreadValues(__spreadValues({}, this.defaults), details.message);
    return new MailDelivery(this, details);
  }
  get logger() {
    return HyperWorker.logger;
  }
};
Mailer.transport = null;
Mailer.send = false;
Mailer.preview = false;
Mailer.templatesRoot = null;
Mailer.defaults = {
  from: "Joe <mailer@example.com>"
};
Mailer = __decorateClass([
  queueAs("mails")
], Mailer);

// src/backend.ts
var import_lodash = __toESM(require("lodash"));
var import_bullmq = require("bullmq");
var import_debug3 = __toESM(require("debug"));
var debug3 = (0, import_debug3.default)("hyperworker:backend");
var sleep = (t) => new Promise((resolve, _reject) => setTimeout(() => resolve(true), t));
var defaultWorkerOpts = {
  lockDuration: 3e4
};
var defaultQueueOpts = {
  streams: {
    events: { maxLen: 1e3 }
  },
  defaultJobOptions: {
    removeOnComplete: true,
    removeOnFail: { count: 100 },
    stackTraceLimit: 5
  }
};
var BullmqBackend = class {
  constructor(workers, connection, opts) {
    this.connection = connection;
    this.workers = workers;
    this.opts = {
      workerOpts: import_lodash.default.merge({}, defaultWorkerOpts, opts == null ? void 0 : opts.workerOpts),
      queueOpts: import_lodash.default.merge({}, defaultQueueOpts, opts == null ? void 0 : opts.queueOpts)
    };
    debug3("opts: %o", this.opts);
    this.bmqueues = workers.map((Klass) => {
      debug3(`adding queue: ${Klass.queueName} from class ${Klass.name}`);
      const q = new import_bullmq.Queue(Klass.queueName, __spreadValues({
        connection: this.connection
      }, this.opts.queueOpts));
      q.on("error", (err) => {
        HyperWorker.logger && HyperWorker.logger.error(`[error] ${err}`);
        HyperWorker.reportError(err);
      });
      const enqueue = (data, opts2) => q.add("job", data, opts2);
      Klass.enqueue = enqueue;
      Klass.queue = q;
      return q;
    });
    this.workers = workers;
  }
  async processJobs() {
    if (this.bmworkers) {
      throw new Error("already processing jobs");
    }
    if (!HyperWorker.logger) {
      throw new Error("logger is missing. did the app boot correctly?");
    }
    const { magenta, bold } = HyperWorker.logger.colors;
    const pref = bold(magenta("workers:"));
    if (!this.workers) {
      throw new Error("you need to wire into your worker first. call 'wireInto(<workers>)'");
    }
    this.bmworkers = this.workers.filter((Klass) => {
      if (Klass.producerOnly) {
        HyperWorker.logger.info(`${pref} producer only job: ${Klass.queueName}`);
        return false;
      }
      return true;
    }).map((Klass) => {
      debug3(`processing queue: ${Klass.queueName} from class ${Klass.name}`);
      return new import_bullmq.Worker(Klass.queueName, async (job) => {
        debug3(`processing job in: ${Klass.queueName}`);
        const w = new Klass();
        await w.perform(job);
      }, __spreadValues({
        connection: this.connection
      }, this.opts.workerOpts));
    });
    this.bmworkers.forEach((w) => {
      w.on("drained", (_job) => {
        HyperWorker.logger.info(`${pref} drained: ${w.name}`);
      });
      w.on("completed", (_job) => {
        HyperWorker.logger.info(`${pref} completed: ${w.name}`);
      });
      w.on("failed", (job, err) => {
        HyperWorker.logger.info(`${pref} failed: ${w.name} (${err})`);
        HyperWorker.reportError(err, { worker: w.name, jobId: job.id });
      });
      w.on("error", (err) => {
        HyperWorker.logger.error(`${pref} error: ${w.name} (${err})`);
        HyperWorker.reportError(err, { worker: w.name });
      });
    });
  }
  async stop() {
    if (this.bmworkers) {
      for (const w of this.bmworkers) {
        if (w) {
          w.connection.removeAllListeners("close");
          w.connection.removeAllListeners("error");
          w.removeAllListeners("error");
          w.removeAllListeners("completed");
          w.removeAllListeners("drained");
          await w.close();
        }
      }
    }
    if (this.bmqueues) {
      for (const q of this.bmqueues) {
        if (q) {
          q.connection.removeAllListeners("close");
          q.connection.removeAllListeners("error");
          q.removeAllListeners("error");
          q.removeAllListeners("completed");
          q.removeAllListeners("drained");
          await q.close();
        }
      }
    }
    await this.connection.quit();
    this.workers = void 0;
    await sleep(500);
  }
};

// src/hyperworker.ts
var debug4 = (0, import_debug4.default)("@hyperstackjs/hyperworker");
var load = (patt) => import_glob.default.sync(patt).map((f) => {
  let mod = null;
  try {
    mod = require(f);
  } catch (e) {
    console.log(`error dynamically loading '${f}'
${e.toString()}`);
    throw e;
  }
  return mod.default || mod;
});
var createBackend = ({
  hyperworkers,
  redis,
  backendOpts
}) => {
  return new BullmqBackend(hyperworkers, redis, backendOpts);
};
var loadWorkers = ({ workersGlob, mailersGlob }) => {
  const workers = import_lodash2.default.reduce(load(workersGlob), import_lodash2.default.merge) || {};
  const mailers = import_lodash2.default.reduce(load(mailersGlob), import_lodash2.default.merge) || {};
  if (Object.keys(workers).includes("default") || Object.keys(mailers).includes("default")) {
    throw new Error("cannot start worker that is exported as default");
  }
  return { workers, mailers };
};
var createConnection = async ({
  redisUrl,
  rejectUnauthorized = false
}) => {
  const Redis = require("ioredis");
  return new Redis(redisUrl, {
    name: "hyperworkers",
    lazyConnect: true,
    maxRetriesPerRequest: null,
    enableReadyCheck: false,
    tls: (redisUrl == null ? void 0 : redisUrl.startsWith("rediss://")) ? {
      rejectUnauthorized
    } : void 0
  });
};
var initializeWorkers = ({
  logger,
  mailerTemplatesRoot,
  mailerSettings
}) => {
  HyperWorker.clear();
  Mailer.clear();
  HyperWorker.initWorker({ logger });
  Mailer.initMailer({
    templatesRoot: mailerTemplatesRoot,
    settings: mailerSettings
  });
};
var buildWorkers = async ({
  isInProcess,
  workersGlob,
  mailersGlob,
  mailerTemplatesRoot,
  mailerSettings,
  logger,
  redisUrl,
  backendOpts,
  truncate = false,
  beforeWorkers = (_p) => {
  },
  afterWorkers = (_p) => {
  }
}, mode) => {
  initializeWorkers({ logger, mailerTemplatesRoot, mailerSettings });
  beforeWorkers({ HyperWorker, Mailer });
  const { workers, mailers } = loadWorkers({
    workersGlob,
    mailersGlob
  });
  const numWorkers = Object.keys(workers).length;
  const numMailers = Object.keys(mailers).length;
  const workerline = `${numWorkers} workers, ${numMailers} mailers`;
  const { magenta, bold } = logger.colors;
  const pref = bold(magenta("workers:"));
  if (isInProcess) {
    debug4("running in-process");
    logger.info(`${pref} [in-process, duplex] ${workerline}`);
    HyperWorker.setMode({ inprocess: isInProcess });
    return {
      background: "inprocess",
      backend: null,
      connection: null,
      mode: "duplex",
      mailerTemplatesRoot,
      numMailers,
      numWorkers,
      workers,
      mailers
    };
  }
  const hyperworkers = [
    ...Object.values(workers),
    ...Object.values(mailers)
  ];
  if (!redisUrl) {
    throw new Error("cannot find a Redis URL");
  }
  debug4("creating a Redis connection");
  const redis = await createConnection({ redisUrl });
  await redis.connect();
  debug4("connected to Redis");
  logger.info(`${pref} [queue, ${mode}] ${workerline}`);
  if (truncate) {
    debug4("truncating Redis content");
    logger.warn(`${pref} truncating Redis contents`);
    await redis.flushdb();
  }
  const b = createBackend({ hyperworkers, redis, backendOpts });
  debug4("created backend");
  HyperWorker.backend = b;
  afterWorkers({ backend: b });
  if (mode === "consumer" || mode === "duplex") {
    debug4("processing jobs: consumer mode");
    b.processJobs();
  }
  return {
    background: "queue",
    backend: b,
    connection: redis,
    mailerTemplatesRoot,
    mode,
    numMailers,
    numWorkers,
    workers,
    mailers
  };
};
// Annotate the CommonJS export names for ESM import in node:
0 && (module.exports = {
  buildWorkers,
  createBackend,
  createConnection,
  loadWorkers
});
