var __create = Object.create;
var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __getProtoOf = Object.getPrototypeOf;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toESM = (mod, isNodeMode, target) => (target = mod != null ? __create(__getProtoOf(mod)) : {}, __copyProps(isNodeMode || !mod || !mod.__esModule ? __defProp(target, "default", { value: mod, enumerable: true }) : target, mod));
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);

// src/worker.ts
var worker_exports = {};
__export(worker_exports, {
  HyperWorker: () => HyperWorker,
  producerOnly: () => producerOnly,
  queueAs: () => queueAs
});
module.exports = __toCommonJS(worker_exports);
var import_reflect_metadata = require("reflect-metadata");
var import_debug = __toESM(require("debug"));
var debug = (0, import_debug.default)("hyperworker:worker");
var K_QUEUE_NAME = "hyperworker:queue-name";
var K_PRODUCER_ONLY = "hyperworker:queue-producer-only";
var queueAs = (queueName) => (target) => {
  return Reflect.defineMetadata(K_QUEUE_NAME, queueName, target);
};
var producerOnly = () => (target) => {
  return Reflect.defineMetadata(K_PRODUCER_ONLY, "true", target);
};
var _HyperWorker = class {
  static clear() {
    this.logger = null;
    this.backend = null;
    this.inprocess = false;
    this.enqueue = null;
    this.reportError = (_err, _tags) => {
    };
  }
  static initWorker({ logger }) {
    this.logger = logger;
  }
  static setMode({
    inprocess,
    reportError
  }) {
    this.inprocess = inprocess;
    if (reportError) {
      this.reportError = reportError;
    }
  }
  static setTest(reportError) {
    this.setMode({ inprocess: true, reportError });
  }
  static get queueName() {
    return Reflect.getOwnMetadata(K_QUEUE_NAME, this) || this.name.toLowerCase();
  }
  static get producerOnly() {
    return Reflect.getOwnMetadata(K_PRODUCER_ONLY, this) || false;
  }
  static async performNow(args) {
    const w = new this();
    return w.perform({ data: args });
  }
  static async performLater(_args) {
    if (this.inprocess) {
      debug(`${this.name}: perform now '%o'`, _args);
      return this.performNow(_args);
    }
    debug(`${this.name}: perform later '%o'`, _args);
    return this.enqueue(_args, {});
  }
  static async jobCounts() {
    return await this.queue.getJobCounts();
  }
  get logger() {
    return _HyperWorker.logger;
  }
  perform(_args) {
  }
};
var HyperWorker = _HyperWorker;
HyperWorker.inprocess = false;
HyperWorker.logger = null;
HyperWorker.backend = null;
HyperWorker.enqueue = null;
HyperWorker.queue = null;
HyperWorker.reportError = (_err, _tags) => {
};
// Annotate the CommonJS export names for ESM import in node:
0 && (module.exports = {
  HyperWorker,
  producerOnly,
  queueAs
});
